import '../miscellaneous/ability.dart';
import 'caste.dart';

class Fighter extends Caste {
  static const String _name = 'Lutador';
  static const String _description = '';
  static const int _initialHealth = 20;
  static const int _healthPerLevel = 5;
  static const int _initialMana = 3;
  static const int _manaPerLevel = 3;
  static const List<Ability> _abilities = [
    Ability('Briga', '', 1),
    Ability('Golpe Relâmpago', '', 1),
    Ability('Casca Grossa', '', 3),
    Ability('Golpe Cruel', '', 5),
    Ability('Golpe Violento', '', 9),
    Ability('Dono da Rua', '', 20),
  ];

  @override
  String get name => _name;

  @override
  String get description => _description;

  @override
  int get initialHealth => _initialHealth;

  @override
  int get healthPerLevel => _healthPerLevel;

  @override
  int get initialMana => _initialMana;

  @override
  int get manaPerLevel => _manaPerLevel;

  @override
  List<Ability> get abilities => _abilities;
}
