import 'package:flutter/foundation.dart';

import '../castes/caste.dart';
import '../races/race.dart';
import 'ability.dart';
import 'attack.dart';
import 'equipment.dart';
import 'skill.dart';
import 'spell.dart';

class CharacterSheet extends ChangeNotifier {
  /// Basics
  String characterName;
  String playerName;
  Race race;
  String origin;
  Caste caste;
  int level;

  /// Attributes
  int strength;
  int dexterity;
  int constitution;
  int intelligence;
  int wisdom;
  int charisma;

  /// Health and Mana
  int totalHeathPoints;
  int currentHealthPoints;
  int temporaryHealthPoints;
  int totalManaPoints;
  int currentManaPoints;
  int temporaryManaPoints;

  List<Attack> attacks = List<Attack>();

  //TODO: Equipped Armor

  //TODO: Equipped Shield

  /// Powers, Class Abilities and Talents
  List<Ability> abilities = List<Ability>();

  /// Tricks and Spells of all cycles
  List<Spell> spells = List<Spell>();

  List<Skill> skills = List<Skill>();

  /// Items
  List<Equipment> equipments = List<Equipment>();
  int tibar;
  int goldTibar;
  int copperTibar;

  String background;
  String observations;

  // TODO: Implement method
  int modifier(int attribute) {
    throw UnimplementedError();
  }

  // TODO: Implement method
  int armorClass() {
    // 10 + dexterity modifier + armor bonus + shield bonus + others.
    throw UnimplementedError();
  }

  // TODO: Implement method
  void levelUp() {
    throw UnimplementedError();
  }

  void changeRace() {
    throw UnimplementedError();
  }

  void changeCaste() {
    throw UnimplementedError();
  }
}
